<template lang="pug">
  .mx-2
    v-row(justify="center", dense)
      v-col(v-if="error")
        .item-col.text-center
          v-card.item-card(outlined, to="/")
            .d-flex.item-icon
              v-icon(x-large, style="margin: auto") mdi-chevron-left
          span.d-block.caption Not found

      v-col(v-else-if="path!='/'")
        .item-col.text-center
          v-card.item-card(outlined, :to="back")
            .d-flex.item-icon
              v-icon(x-large, style="margin: auto") mdi-chevron-left
          span.d-block.caption ..
          
      template(v-for="file, i in files.slice().sort((x, y) => (y.new - x.new) || (!!(y.new_items||0) - !!(x.new_items||0)))")
        v-col(:key="`icon-${file.name}`", v-if="file.type=='dir'")
          .item-col.text-center
            v-card.item-card(outlined, :to="path+file.name")
              .d-flex.item-icon
                v-badge(overlap, style="margin: auto")
                  template(v-slot:badge, v-if="file.new") !
                  template(v-slot:badge, v-else-if="file.new_items") {{file.new_items}}
                  v-icon(x-large) mdi-folder
            span.d-block.caption {{file.name}}
        
        v-col(:key="`icon-${file.name}`", v-else-if="file.type=='png'")
          .item-col.text-center
            v-card.item-card(outlined, :href="file.link", target="_blank")
              v-badge.d-block(overlap)
                template(v-slot:badge, v-if="file.new") !
                v-img(:src="file.icon", max-height=96, max-width=96, contain, style="width: 96px; height: 96px; margin: auto")
            span.d-block.caption {{file.name}}.png

        v-col(:key="`icon-${file.name}`", v-else-if="file.type=='json'")
          .item-col.text-center(v-if="file.csv")
            v-card.item-card(outlined, :href="file.csv", target="_blank")
              .d-flex.item-icon
                v-badge(overlap, style="margin: auto")
                  template(v-slot:badge, v-if="file.new") !
                  v-icon(x-large, style="margin: auto") mdi-table
            span.d-block.caption {{file.name}}.csv
          .item-col.text-center(v-else)
            v-card.item-card(outlined, :href="file.link", target="_blank")
              .d-flex.item-icon
                v-badge(overlap, style="margin: auto")
                  template(v-slot:badge, v-if="file.new") !
                  v-icon(x-large, style="margin: auto") mdi-json
            span.d-block.caption {{file.name}}.json

        v-col(:key="`icon-${file.name}`", v-else-if="file.type=='mp3'")
          .item-col.text-center
            v-card.item-card(outlined, :href="file.link", target="_blank")
              .d-flex.item-icon
                v-badge(overlap, style="margin: auto")
                  template(v-slot:badge, v-if="file.new") !
                  v-icon(x-large, style="margin: auto") mdi-music
            span.d-block.caption {{file.name}}.mp3

        v-col(:key="`icon-${file.name}`", v-else)
          .item-col.text-center
            v-card.item-card(outlined, :href="file.link", target="_blank")
              .d-flex.item-icon
                v-badge(overlap, style="margin: auto")
                  template(v-slot:badge, v-if="file.new") !
                  v-icon(x-large, style="margin: auto") mdi-file
            span.d-block.caption {{file}}

        v-responsive(:key="`responsive-${i}`", width="100%", v-if="(i+1+(path!='/'))%cols==0")
      
      v-col(v-for="i in (cols-(files.length+(path!='/'))%cols)%cols", :key="i")
</template>

<script>
export default {
  name: 'IconView',
  props: ['files', 'error'],
  computed: {
    path() {
      const p = this.$route.path;
      if (p.endsWith('/')) {
        return p;
      }
      return p + '/';
    },
    back() {
      return this.path.split('/').slice(0, -2).join('/') + '/';
    },
    cols() {
      return Math.floor(this.$vuetify.breakpoint.width / 112);
    }
  },
};
</script>

<style>
.item-col {
  margin: auto;
  width: 100px;
  word-break: break-all;
}

.item-card {
  width: 98px;
}

.item-icon {
  height: 96px;
  width: 96px;
}
</style>